#import "SnapToGridPrincipal.h"
#import "SnapToGridGraphView.h"


// this has to be a global because poseAsClass classes can't add instance variables.
int SnapToGridSpacing;


@implementation SnapToGridGraphView
- (id)initWithFrame:(struct _NSRect)fp8
{
	id z=[super initWithFrame:fp8];
	if(z)
	{
		NSDictionary *d=[[NSBundle bundleForClass:[SnapToGridPlugin class]] infoDictionary];
		SnapToGridSpacing = [[d objectForKey:@"SnapToGridSpacing"] intValue];
	}
	return z;
}

- (struct _NSRect)boundsForNode:(id)fp8
{
	struct _NSPoint p=[[[fp8 userInfo] valueForKey:@"position"] pointValue];
	
	// the "+ 0.5" shifts the snap threshold from the left side to the center of the SnapToGridSpacing, so that if you just drag one pixel left, it doesn't immediately snap to the next grid space.
	p.x = ((int)(p.x/SnapToGridSpacing + 0.5)) * SnapToGridSpacing;
	p.y = ((int)(p.y/SnapToGridSpacing + 0.5)) * SnapToGridSpacing;

	[(NSMutableDictionary *)[fp8 userInfo] setObject:[NSValue valueWithPoint:p] forKey:@"position"];

	return [super boundsForNode:fp8];
}
@end
